"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var copy_webpack_plugin_1 = tslib_1.__importDefault(require("copy-webpack-plugin"));
var plugins_1 = require("./plugins");
var path_1 = tslib_1.__importDefault(require("path"));
function mwDLL(context, next) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var dll, plugins, DIRs, libraryName, dllPath, manifest, dllFileName;
        return tslib_1.__generator(this, function (_a) {
            context.dll = false;
            context.DLL_FILENAME = false;
            next();
            dll = context.dll, plugins = context.plugins, DIRs = context.DIRs;
            libraryName = '[name]_[hash]';
            if (Array.isArray(dll)) {
                plugins.push(new plugins_1.DllPlugin({
                    path: path_1.default.resolve(DIRs.build, 'manifest.json'),
                    name: libraryName,
                    context: context.context || context.cwd
                }));
                context.output = {
                    path: DIRs.build,
                    filename: libraryName + ".js",
                    library: libraryName
                };
                context.entry = { dll: dll };
            }
            if (typeof dll === 'string' || dll === true) {
                dllPath = dll === true ? path_1.default.resolve(DIRs.root, 'dll') : dll;
                manifest = require(path_1.default.join(dllPath, 'manifest.json'));
                dllFileName = manifest.name + ".js";
                plugins.push(new plugins_1.DllReferencePlugin({
                    context: context.context || context.cwd,
                    manifest: manifest
                }));
                plugins.push(new copy_webpack_plugin_1.default([
                    {
                        from: path_1.default.join(dllPath, dllFileName),
                        to: DIRs.build
                    }
                ]));
                context.DLL_FILENAME = dllFileName;
            }
            return [2];
        });
    });
}
exports.default = mwDLL;
